/*
    The code in this file uses open source libraries provided by thecoderscorner

    DO NOT EDIT THIS FILE, IT WILL BE GENERATED EVERY TIME YOU USE THE UI DESIGNER
    INSTEAD EITHER PUT CODE IN YOUR SKETCH OR CREATE ANOTHER SOURCE FILE.

    All the variables you may need access to are marked extern in this file for easy
    use elsewhere.
 */

#include <tcMenu.h>
#include "stm32f429FrameBuffer_menu.h"
#include "ThemeCoolBlueModern.h"
#include "Fonts/FreeSans12pt7b.h"

// Global variable declarations
const  ConnectorLocalInfo applicationInfo = { "Factory", "4df3d784-674a-4a3d-bcee-54a49693788e" };

StChromaArtDrawable Drawable;
GraphicsDeviceRenderer renderer(30, applicationInfo.name, &Drawable);
StBspTouchInterrogator touchInterrogator(240, 320);
MenuTouchScreenManager touchScreen(&touchInterrogator, &renderer, iotouch::TouchInterrogator::PORTRAIT);

// Global Menu Item declarations
const BooleanMenuInfo minfoConnectivityEnableUSB = { "Enable USB", 10, 8, 1, NO_CALLBACK, NAMING_TRUE_FALSE };
BooleanMenuItem menuConnectivityEnableUSB(&minfoConnectivityEnableUSB, false, NULL);
RENDERING_CALLBACK_NAME_INVOKE(fnConnectivityRtCall, backSubItemRenderFn, "Connectivity", -1, NO_CALLBACK)
const SubMenuInfo minfoConnectivity = { "Connectivity", 9, 0xffff, 0, NO_CALLBACK };
BackMenuItem menuBackConnectivity(fnConnectivityRtCall, &menuConnectivityEnableUSB);
SubMenuItem menuConnectivity(&minfoConnectivity, &menuBackConnectivity, NULL);
RENDERING_CALLBACK_NAME_INVOKE(fnSettingsRunDurationRtCall, timeItemRenderFn, "Run duration", 4, NO_CALLBACK)
TimeFormattedMenuItem menuSettingsRunDuration(fnSettingsRunDurationRtCall, 8, (MultiEditWireType)6, NULL);
const AnalogMenuInfo minfoSettingsTargetSpeed = { "Target speed", 7, 2, 200, onTargetChanged, 0, 100, "mS" };
AnalogMenuItem menuSettingsTargetSpeed(&minfoSettingsTargetSpeed, 0, &menuSettingsRunDuration);
RENDERING_CALLBACK_NAME_INVOKE(fnSettingsRtCall, backSubItemRenderFn, "Settings", -1, NO_CALLBACK)
const SubMenuInfo minfoSettings = { "Settings", 5, 0xffff, 0, NO_CALLBACK };
BackMenuItem menuBackSettings(fnSettingsRtCall, &menuSettingsTargetSpeed);
SubMenuItem menuSettings(&minfoSettings, &menuBackSettings, &menuConnectivity);
const AnalogMenuInfo minfoConsumption = { "Consumption", 4, 0xffff, 4000, NO_CALLBACK, 0, 1, "W" };
AnalogMenuItem menuConsumption(&minfoConsumption, 0, &menuSettings);
const AnalogMenuInfo minfoACLine = { "AC Line", 3, 0xffff, 2600, NO_CALLBACK, 0, 10, "V" };
AnalogMenuItem menuACLine(&minfoACLine, 0, &menuConsumption);
const AnalogMenuInfo minfoBeltSpeed = { "Belt Speed", 2, 0xffff, 200, NO_CALLBACK, 0, 100, "mS" };
AnalogMenuItem menuBeltSpeed(&minfoBeltSpeed, 0, &menuACLine);
const char enumStrBeltStatus_0[] = "Running";
const char enumStrBeltStatus_1[] = "Warm Up";
const char enumStrBeltStatus_2[] = "Stopped";
const char* const enumStrBeltStatus[]  = { enumStrBeltStatus_0, enumStrBeltStatus_1, enumStrBeltStatus_2 };
const EnumMenuInfo minfoBeltStatus = { "Belt Status", 1, 0xffff, 2, NO_CALLBACK, enumStrBeltStatus };
EnumMenuItem menuBeltStatus(&minfoBeltStatus, 0, &menuBeltSpeed);
const BooleanMenuInfo minfoPower = { "Power", 6, 0xffff, 1, NO_CALLBACK, NAMING_ON_OFF };
BooleanMenuItem menuPower(&minfoPower, false, &menuBeltStatus);

void setupMenu() {
    // First we set up eeprom and authentication (if needed).

    // Now add any readonly, non-remote and visible flags.
    menuBeltSpeed.setReadOnly(true);
    menuBeltStatus.setReadOnly(true);

    // Code generated by plugins.
    renderer.setUpdatesPerSecond(10);
    touchScreen.start();
    menuMgr.initWithoutInput(&renderer, &menuPower);
    renderer.setTitleMode(BaseGraphicalRenderer::TITLE_FIRST_ROW);
    renderer.setUseSliderForAnalog(true);
    installCoolBlueModernTheme(renderer, MenuFontDef(&FreeSans12pt7b, 1), MenuFontDef(&FreeSans12pt7b, 1), false);
}

